		name	home
;
; subroutine home: assembly language routine that uses the video
; bios call to home the cursor
;
; fortran call is : call home
;
;
;	interface to IBM professional fortran 1.0

stack_size	equ	6	; number of bytes needed on stack

data		segment
		db	'home    '
sp_save	dw	?
		dd	home
		dd	0
data		ends



;
code		segment	'code'
		assume	cs:code,ds:data,es:nothing,ss:nothing
		public	home
home		proc		far


;----------execute Profort standard entry linkage--------------------

		push	ds
		sub	bp,stack_size+6
		mov	ax,data
		mov	ds,ax
		mov	sp_save,sp
		mov	sp,bp
;---------------------------------------------------------------------

;	make call for video parameters to get the number of the
;	active page needed by the video bios set cursor command

		mov	ah,15		; get current video state
		int	10h		; call video bios

;	active page is in bh. 
		mov	dx,0		; cursor to (0,0)
		mov	ah,2		; set cursor
		int	10h		; call video bios

;-------------perform exit linkage------------------------------------

		add	sp,stack_size+2
		ret
;---------------------------------------------------------------------

home		endp
code		ends
		end

stack		segment word stack 'stack'
		db	stack_size dup(?)
stack		ends
		end
